﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="WebHierarchicalDataGrid_Manual_Crud.aspx.cs" Inherits="_Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<%@ Register Assembly="Infragistics45.Web.v14.2, Version=14.2.20142.1028, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.GridControls" TagPrefix="ig" %>

<%@ Register assembly="Infragistics45.Web.v14.2, Version=14.2.20142.1028, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" namespace="Infragistics.Web.UI.ListControls" tagprefix="ig" %>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Manual Crud Sample</title>
</head>
<body>
    <form id="form1" runat="server">
   
    <h3  style="margin: 25px;">WebHierarchicalDataGrid Manual Crud Operations</h3>

    <div style="margin: 25px;">
        <asp:ScriptManager runat="server">
        </asp:ScriptManager>
        <ig:WebHierarchicalDataGrid ID="WebHierarchicalDataGrid1" runat="server" Width="98%"
            InitialDataBindDepth="-1" AutoGenerateColumns="False" OnRowUpdating="WebHierarchicalDataGrid1_RowUpdating">
            <EditorProviders>
                <ig:DropDownProvider ID="WebHierarchicalDataGrid1_DropDownProvider1">
                    <EditorControl DropDownContainerMaxHeight="200px" EnableAnimations="False" 
                        EnableDropDownAsChild="False" DropDownContainerWidth="200px" >
                        <Items>
                            <ig:DropDownItem Selected="False" Text="Item1">
                            </ig:DropDownItem>
                            <ig:DropDownItem Selected="False" Text="Item2">
                            </ig:DropDownItem>
                            <ig:DropDownItem Selected="False" Text="Item3">
                            </ig:DropDownItem>
                            <ig:DropDownItem Selected="False" Text="Item4">
                            </ig:DropDownItem>
                        </Items>
                    </EditorControl>
                </ig:DropDownProvider>
            </EditorProviders>
            <Columns>
                <ig:TemplateDataField Key="DeleteItem" Width="70px">
                    <ItemTemplate>
                        <asp:Button Text="Delete" ID="Button1" runat="server" OnClientClick="DeleteParentRow(); return false;" />
                    </ItemTemplate>
                </ig:TemplateDataField>
                <ig:BoundDataField DataFieldName="ActorID" Key="ActorID" Header-Text="Actor ID">
                    <Header Text="Actor ID"></Header>
                </ig:BoundDataField>
                <ig:BoundDataField DataFieldName="Name" Key="Name" Header-Text="Name">
                    <Header Text="Name"></Header>
                </ig:BoundDataField>
            </Columns>
            <Bands>
                <ig:Band DataKeyFields="MovieID" DataMember="Movies" Key="MovieID" AutoGenerateColumns="false">
                    <Columns>
                        <ig:TemplateDataField Key="DeleteItem" Width="70px">
                            <ItemTemplate>
                                <asp:Button Text="Delete" ID="Button1" runat="server" OnClientClick="DeleteChildRow(); return false;" />
                            </ItemTemplate>
                        </ig:TemplateDataField>
                        <ig:BoundDataField DataFieldName="MovieID" Key="Movie ID" Header-Text="MovieID">
                            <Header Text="MovieID"></Header>
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="Title" Key="Title" Header-Text="Title">
                            <Header Text="Title"></Header>
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="Year" Key="Year" Header-Text="Year">
                            <Header Text="Year"></Header>
                        </ig:BoundDataField>
                    </Columns>
                    <Behaviors>
                        <ig:EditingCore>
                            <Behaviors>
                               <ig:CellEditing Enabled="true" EditModeActions-EnableF2="true" EnableInheritance="true">
                                <ColumnSettings>
                                    <ig:EditingColumnSetting ColumnKey="Year" EditorID="WebHierarchicalDataGrid1_DropDownProvider1" />
                                </ColumnSettings>
                                </ig:CellEditing>
                            </Behaviors>
                        </ig:EditingCore>
                    </Behaviors>
                </ig:Band>
            </Bands>
            <Behaviors>
                <ig:EditingCore Enabled="true" EnableInheritance="true" AutoCRUD="false">
                    <EditingClientEvents RowAdded="WebHierarchicalDataGrid1_AfterInsertRow" RowAdding="WebHierarchicalDataGrid1_BeforeInsertRow"/>
                    <Behaviors>
                        <ig:CellEditing Enabled="true" EditModeActions-EnableF2="true" EnableInheritance="true">
                            <ColumnSettings>
                                <ig:EditingColumnSetting ColumnKey="ActorID" ReadOnly="true" />
                                <ig:EditingColumnSetting ColumnKey="Year" EditorID="WebHierarchicalDataGrid1_DropDownProvider1" />
                                 <ig:EditingColumnSetting ColumnKey="Year"  ReadOnly="true" />
                            </ColumnSettings>
                        </ig:CellEditing>
                        <ig:RowAdding EnableInheritance="true">
                            <ColumnSettings>
                                <ig:RowAddingColumnSetting ColumnKey="ActorID" ReadOnly="true" />
                            </ColumnSettings>
                        </ig:RowAdding>
                        <ig:RowDeleting EnableInheritance="true" />
                    </Behaviors>
                </ig:EditingCore>
                <ig:Selection RowSelectType="Single" CellClickAction="Row" />
                <ig:Paging PageSize="10">
                </ig:Paging>
            </Behaviors>
        </ig:WebHierarchicalDataGrid>

        <script type="text/javascript">
        function DeleteParentRow() {
            var grid = $find('<%= this.WebHierarchicalDataGrid1.ClientID %>');
            var gridRows = grid.get_gridView().get_rows();

            var selectedRows = grid.get_gridView().get_behaviors().get_selection().get_selectedRows();
            for (var i = selectedRows.get_length() - 1; i >= 0; i--) {
                var row = selectedRows.getItem(i);
                gridRows.remove(row);
            }
        }


        function DeleteChildRow() {
            var grid = $find('<%= this.WebHierarchicalDataGrid1.ClientID %>');
            var gridRows = grid.get_gridView().get_rows();
            var childRows = [];
            var selectedRows = [];

            for (var i = 0; i < gridRows.get_length(); i++) {
                childRows[i] = gridRows.get_row(i).get_rowIslands()[0].get_rows();
                selectedRows[i] = gridRows.get_row(i).get_rowIslands()[0].get_behaviors().get_selection().get_selectedRows();
            }
            for (var i = 0; i < gridRows.get_length(); i++) {
                for (var j = selectedRows[i].get_length() - 1; j >= 0; j--) {
                    childRows[i].remove(selectedRows[i].getItem(j));
                }
            }

        }


            function WebHierarchicalDataGrid1_BeforeInsertRow(sender, e)
            {
                alert('Test before Insert row ...');
            }


            function WebHierarchicalDataGrid1_AfterInsertRow()
            {
                alert('Test after than a row was inserted');
            }



        </script>

    </div>
    </form>
</body>
</html>
